// MCKEYGEN by akacastor [ AP Class ] 2024-05-01
// 
// This keygen has been tested and found working on:
//
// McRace 2.2 - Motor City Dragstrip
// McTrivia 2.00
// McBowl 2.0
//


#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <ctype.h>


#define KEYFILE_SIZE    243
/*
keyfile is 243 bytes long.

0x00 pascal string = bbs name
0x50 pascal string = sysop name
0xA0 pascal string "MASTER" identifies a master key  or else should match key filename
0xA9 word is checksum of 0xA0 string
0xBB word \
0xBD word  } beta key / expiration-related (can be zero)
0xBF word /
0xC7 word \ 32-bit hash value
0xC9 word /
0xCB byte nonzero = beta key
0xCC word = days until expiration (can be zero)
0xD0 word beta key / expiration-related (can be zero)
*/


int main(int argc, char **argv)
{
    uint8_t keydata[KEYFILE_SIZE];
    FILE *keyfile;
    char keybasename[9] = "MCSOFT";
    char keyfilename[13];
    int i;
    int sysop_sum;
    int bbs_sum;
    int filename_sum;
    uint32_t key_hash;


    printf( "McKeyGen by akacastor [ AP Class ] 2024-05-01\n\n" );
    printf( "Keygen for Motor City Software doors including:\n" 
            " McRace 2.2 - Motor City Dragstrip, McTrivia 2.0, McBowl 2.0\n\n" );

    if( argc < 3 )
    {
        printf( "usage: %s <\"BBS Name\"> <\"SysOp Name\"> [\"Key Name\"]\n", argv[0] );
        return 1;
    }
    
    memset( keydata, 0, KEYFILE_SIZE );

    // copy BBS name from command line
    keydata[0] = strlen(argv[1]);
    for( i=0; i<strlen(argv[1]) && i<0x4E; i++ )
        keydata[1+i] = toupper( argv[1][i] );       // convert name to all uppercase for compatibility with some doors (ie. MCBOWL)

    // copy sysop name from command line
    keydata[0x50] = strlen(argv[2]);
    for( i=0; i<strlen(argv[2]) && i<0x4E; i++ )
        keydata[0x51+i] = toupper( argv[2][i] );    // convert name to all uppercase for compatibility with some doors (ie. MCBOWL)

    // copy key filename from command line
    if( argc > 3 )
        strncpy( keybasename, argv[3], 8 );

    keydata[0xA0] = strlen(keybasename);
    for( i=0; i<strlen(keybasename) && i<8; i++ )
        keydata[0xA1+i] = toupper( keybasename[i] );    // convert name to all uppercase (filenames are all uppercase)

    // calculate sums
    sysop_sum = 0;
    for( i=0; i<strlen(keydata+0x51); i++ )
        sysop_sum += keydata[0x51+i];

    bbs_sum = 0;
    for( i=0; i<strlen(keydata+0x1); i++ )
        bbs_sum += keydata[0x1+i];

    filename_sum = 0;
    for( i=0; i<strlen(keydata+0xA1); i++ )
        filename_sum += keydata[0xA1+i];

    keydata[0xA9] = filename_sum & 0xFF;
    keydata[0xAA] = (filename_sum>>8) & 0xFF;

    key_hash = sysop_sum * keydata[0x50];
    key_hash += keydata[0];
    key_hash *= bbs_sum;

    // save hash to key file    
    keydata[0xC7] = key_hash & 0xFF;
    keydata[0xC8] = (key_hash>>8) & 0xFF;
    keydata[0xC9] = (key_hash>>16) & 0xFF;
    keydata[0xCA] = (key_hash>>24) & 0xFF;

    // print registration info being used
    printf( "Registering to:\n");
    printf( " Sysop: %s\n", keydata+0x51 );
    printf( " BBS:   %s\n", keydata+1 );

    // write key file to disk
    sprintf( keyfilename, "%s.KEY", keybasename );
    printf( "Writing %s...\n", keyfilename );

    keyfile = fopen( keyfilename, "wb" );
    if( !keyfile )
    {
        printf( "Error - Unable to write keyfile - aborting.\n" );
        return 2;
    }
    
    if( fwrite( keydata, KEYFILE_SIZE, 1, keyfile ) < 1 )
        printf( "Error writing to keyfile.\n" );
    
    fclose( keyfile );

    printf( "Done.\n" );

    
    return 0;
}
